Scriptname RiftSwordConstantScript extends ActiveMagicEffect  

SPELL PROPERTY RiftSwordConstantSpell AUTO
SPELL PROPERTY RiftSwordMuffleSpell AUTO
SPELL PROPERTY RiftSwordEtherealSpell AUTO
SPELL PROPERTY RiftSwordInvisibilitySpell AUTO
SPELL PROPERTY RiftSwordPortalSpell AUTO
SPELL PROPERTY RiftSwordDamageRates AUTO
MAGICEFFECT PROPERTY RiftSwordInvisibilityEffect AUTO

STATIC PROPERTY RiftSwordPortalStatic AUTO
OBJECTREFERENCE PROPERTY RiftSwordPortal AUTO
OBJECTREFERENCE PROPERTY RiftSwordPortalExit AUTO
WEAPON PROPERTY RiftSword AUTO
SOUND PROPERTY MAGConjurePortalSD AUTO


EVENT OnEffectStart(Actor akTarget, Actor akCaster)
	
	;Debug.Notification("Registering weaponSwing Animation")		
	registerForAnimationEvent(akCaster, "weaponSwing")		
	
	;Debug.Notification("Registering weaponLeftSwing Animation")		
	registerForAnimationEvent(akCaster, "weaponLeftSwing")		

ENDEVENT



Event OnAnimationEvent(ObjectReference akActor, string EventName)
	
	If ((EventName == "weaponSwing" && Game.GetPlayer().GetEquippedWeapon() == RiftSword) || (EventName == "weaponLeftSwing" && Game.GetPlayer().GetEquippedWeapon(True) == RiftSword)) && akActor == Game.GetPlayer() && Game.GetPlayer().IsWeaponDrawn() == True && Game.GetPlayer().IsInCombat() == False && Game.GetPlayer().GetAnimationVariableBool("bAllowRotation") && !Game.GetPlayer().GetAnimationVariableBool("isBlocking") && !Game.GetPlayer().GetAnimationVariableBool("isBashing") && !Game.GetPlayer().GetAnimationVariableBool("isSneaking") && Game.GetPlayer().HasMagicEffect(RiftSwordInvisibilityEffect) == False
	
		;Debug.Notification("weaponSwing Detected")
		RiftSwordPortal = Game.GetPlayer().PlaceAtMe(RiftSwordPortalStatic)
		RiftSwordMuffleSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		Utility.Wait(0.2)
		;RiftSwordEtherealSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		;Utility.Wait(0.2)			
		;RiftSwordPortalSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		;Utility.Wait(0.2)			
		RiftSwordInvisibilitySpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		Utility.Wait(0.2)
		;Debug.Notification("Registering for Update")	
		RegisterForUpdate(1.0)
		
		;Debug.Notification("Damaging Regeneration")
		Game.GetPlayer().AddSpell(RiftSwordDamageRates, False)
		;If Game.GetPlayer().GetAV("HealRate") > 0
		;	Game.GetPlayer().ModAV("HealRate", -1000)	
		;EndIf			
		;If Game.GetPlayer().GetAV("StaminaRate") > 0
		;	Game.GetPlayer().ModAV("StaminaRate", -1000)	
		;EndIf	
		;If Game.GetPlayer().GetAV("MagickaRate") > 0
		;	Game.GetPlayer().ModAV("MagickaRate", -1000)	
		;EndIf
		
		Utility.Wait(2.0)
		RiftSwordPortal.Disable(True)		
				  
	EndIf

EndEvent



EVENT OnUpdate()

	If Game.GetPlayer().IsWeaponDrawn() == True && Game.GetPlayer().HasMagicEffect(RiftSwordInvisibilityEffect) == True
	
		If Game.GetPlayer().GetAV("Health") > 20
			Game.GetPlayer().DamageAV("Health", 2)
		EndIf	
	
		If Game.GetPlayer().GetAV("Stamina") > 2
			Game.GetPlayer().DamageAV("Stamina", 2)
		EndIf

		If Game.GetPlayer().GetAV("Magicka") > 2
			Game.GetPlayer().DamageAV("Magicka", 2)
		EndIf		
	
	Else
	
		;Debug.Notification("Unregistered for Update")	
		UnregisterForUpdate()
		UnregisterForUpdate()
		Int instanceID1 = MAGConjurePortalSD.Play(Game.GetPlayer())
		Sound.SetInstanceVolume(instanceID1, 0.75)			
		RiftSwordPortalExit = Game.GetPlayer().PlaceAtMe(RiftSwordPortalStatic)
		;Debug.Notification("Rift Sword Spells Dispeled")
		RiftSwordPortal.Disable(True)
		Game.GetPlayer().DispelSpell(RiftSwordMuffleSpell)	
		Game.GetPlayer().DispelSpell(RiftSwordEtherealSpell)
		Game.GetPlayer().DispelSpell(RiftSwordPortalSpell)
		Game.GetPlayer().DispelSpell(RiftSwordInvisibilitySpell)
		Utility.Wait(2.0)
		RiftSwordPortalExit.Disable(True)	
		
		;Debug.Notification("Restoring Regeneration")
		Game.GetPlayer().RemoveSpell(RiftSwordDamageRates)		
		;If Game.GetPlayer().GetAV("HealRate") < 0
		;	Game.GetPlayer().ModAV("HealRate", 1000)	
		;EndIf			
		;If Game.GetPlayer().GetAV("StaminaRate") < 0
		;	Game.GetPlayer().ModAV("StaminaRate", 1000)	
		;EndIf	
		;If Game.GetPlayer().GetAV("MagickaRate") < 0
		;	Game.GetPlayer().ModAV("MagickaRate", 1000)	
		;EndIf
		
	EndIf

ENDEVENT



EVENT OnEffectFinish(Actor akTarget, Actor akCaster)
	
	;Debug.Notification("Unregistered for Update")	
	UnregisterForUpdate()
	UnregisterForUpdate()
	;Int instanceID1 = MAGConjurePortalSD.Play(Game.GetPlayer())
	;Sound.SetInstanceVolume(instanceID1, 0.75)		
	;Debug.Notification("Unregistered Animation Event")		
	UnregisterForAnimationEvent(akCaster, "weaponSwing")
	UnregisterForAnimationEvent(akCaster, "weaponSwing")	
	UnregisterForAnimationEvent(akCaster, "weaponLeftSwing")
	UnregisterForAnimationEvent(akCaster, "weaponLeftSwing")	
	;Debug.Notification("Rift Sword Spells Dispeled")
	RiftSwordPortal.Disable(True)
	RiftSwordPortalExit.Disable(True)	
	Game.GetPlayer().DispelSpell(RiftSwordMuffleSpell)	
	Game.GetPlayer().DispelSpell(RiftSwordEtherealSpell)
	Game.GetPlayer().DispelSpell(RiftSwordInvisibilitySpell)
	Game.GetPlayer().DispelSpell(RiftSwordPortalSpell)	
	Game.GetPlayer().DispelSpell(RiftSwordMuffleSpell)	
	Game.GetPlayer().DispelSpell(RiftSwordEtherealSpell)
	Game.GetPlayer().DispelSpell(RiftSwordInvisibilitySpell)
	Game.GetPlayer().DispelSpell(RiftSwordPortalSpell)	
	RiftSwordPortal.Disable(True)
	RiftSwordPortalExit.Disable(True)
	
	;Debug.Notification("Restoring Regeneration")
	Game.GetPlayer().RemoveSpell(RiftSwordDamageRates)	
	;If Game.GetPlayer().GetAV("HealRate") < 0
	;	Game.GetPlayer().ModAV("HealRate", 1000)	
	;EndIf			
	;If Game.GetPlayer().GetAV("StaminaRate") < 0
	;	Game.GetPlayer().ModAV("StaminaRate", 1000)	
	;EndIf	
	;If Game.GetPlayer().GetAV("MagickaRate") < 0
	;	Game.GetPlayer().ModAV("MagickaRate", 1000)	
	;EndIf		
	
ENDEVENT